#pragma once

#include <iostream>
#include <iomanip>
#include <TNL/Timer.h>
#include "OverloadedOperators.h"
#include <TNL/Containers/Vector.h>
#include <TNL/Experimental/ExpressionTemplates/VectorExpressions.h>
//#include <TNL/Experimental/ExpressionTemplates/VectorExpressionsWithReferences.h>

using namespace std;
using namespace TNL;
using namespace TNL::Containers;

int main()
{   
    
    Vector< double, Devices::Host, int > d1a( 10 );
    for( int i = 0; i < 10; i++)
        d1a[i] = 1.5;
    Vector< double, Devices::Host, int > d1b( 10 );
    for( int i = 0; i < 10; i++)
        d1b[i] = 3;
    Vector< double, Devices::Host, int > dr1( 10 );

    VectorView< double, Devices::Host, int > dv1a( d1a );
    VectorView< double, Devices::Host, int > dv1b( d1b );
    VectorView< double, Devices::Host, int > dvr1( dr1 );

    TNL::Timer t4;
    
    long double dtm1 = 0;
    
    long double dtmt1 = 0;
    
    int numb = 200000;

    //dynamic vectors
    
    t4.start();
    for( int i = 0; i < numb; i++ )
        dvr1.evaluateFor( dv1a + dv1b );
    t4.stop();
    dtm1 = t4.getCPUCycles();
    dtmt1 = t4.getCPUTime();

    
    //std::cout << std::fixed;
    std::cout << std::setprecision(2);

    std::cout << dtm1 << "/n" << dtmt1 << std::endl;
 
    return 0;
}
