#pragma once

#include <iostream>
#include <iomanip>
#include <TNL/Timer.h>
#include "OverloadedOperators.h"  
#include <TNL/Containers/StaticVector.h>

using namespace std;
using namespace TNL;
using namespace TNL::Containers;

void expression_temp()
{   
    StaticVector< 2, double > sv1( 1.0 );
    StaticVector< 2, double > sv2( 2.0 );
    StaticVector< 2, double > sv3( 3.0 );
    StaticVector< 2, double > svr( 0.0 );
    
    svr = sv1 + sv3 + sv2 + sv3 + sv1;
}

void pure_c()
{
    StaticVector< 2, double > sv1( 1.0 );
    StaticVector< 2, double > sv2( 2.0 );
    StaticVector< 2, double > sv3( 3.0 );
    StaticVector< 2, double > svr( 0.0 );

    for( int i = 0; i < 2; i++ )
    {
        svr[ i ] = sv1[ i ] + sv3[ i ] + sv2[ i ] + sv3[ i ] + sv1[ i ];
    }
}

int main()
{
    TNL::Timer t4;
    
    long double tm1 = 0, tm2 = 0; 
    
    t4.reset();
    t4.start();
    expression_temp();
    t4.stop();
    tm1 = t4.getCPUCycles();

    t4.reset();
    t4.start();
    pure_c();
    t4.stop();
    tm2 = t4.getCPUCycles();

    //std::cout << std::fixed;
    std::cout << std::setprecision(2);
    
    std::cout << tm1 << "\t" << tm2 << std::endl;

    return 0;
}
