#pragma once

#include <iostream>
#include <iomanip>
#include <TNL/Timer.h>
#include "OverloadedOperators.h"
#include <TNL/Containers/Vector.h>
#include <TNL/Experimental/ExpressionTemplates/VectorExpressions.h>
//#include <TNL/Experimental/ExpressionTemplates/VectorExpressionsWithReferences.h>

using namespace std;
using namespace TNL;
using namespace TNL::Containers;

void expression_temp()
{   
    Vector< double, Devices::Host, int > v1( 2 );
    for( int i = 0; i < 2; i++)
        v1[i] = 1;
    Vector< double, Devices::Host, int > v2( 2 );
    for( int i = 0; i < 2; i++)
        v2[i] = 2;
    Vector< double, Devices::Host, int > v3( 2 );
    for( int i = 0; i < 2; i++)
        v3[i] = 3;
    Vector< double, Devices::Host, int > vr( 2 );
    VectorView< double, Devices::Host, int > vv1( v1 );
    VectorView< double, Devices::Host, int > vv2( v2 );
    VectorView< double, Devices::Host, int > vv3( v3 );
    VectorView< double, Devices::Host, int > vvr( vr );
    
    vvr.evaluateFor( vv1 + vv3 + vv2 + vv3 + vv1 );
}

void pure_c()
{
    Vector< double, Devices::Host, int > v1( 2 );
    for( int i = 0; i < 2; i++)
        v1[i] = 1;
    Vector< double, Devices::Host, int > v2( 2 );
    for( int i = 0; i < 2; i++)
        v2[i] = 2;
    Vector< double, Devices::Host, int > v3( 2 );
    for( int i = 0; i < 2; i++)
        v3[i] = 3;
    Vector< double, Devices::Host, int > vr( 2 );
    VectorView< double, Devices::Host, int > vv1( v1 );
    VectorView< double, Devices::Host, int > vv2( v2 );
    VectorView< double, Devices::Host, int > vv3( v3 );
    VectorView< double, Devices::Host, int > vvr( vr );

    for( int i = 0; i < 2; i++ )
    {
        vvr[ i ] = vv1[ i ] + vv3[ i ] + vv2[ i ] + vv3[ i ] + vv1[ i ];
    }
}

int main()
{
    TNL::Timer t4;
    
    long double tm1 = 0, tm2 = 0; 
    
    t4.reset();
    t4.start();
    expression_temp();
    t4.stop();
    tm1 = t4.getCPUCycles();

    t4.reset();
    t4.start();
    pure_c();
    t4.stop();
    tm2 = t4.getCPUCycles();

    //std::cout << std::fixed;
    std::cout << std::setprecision(2);
    
    std::cout << tm1 << "\t" << tm2 << std::endl;

    return 0;
}
